// deadlock.c

#include <stdio.h>
#include <unistd.h>
#include <pthread.h>

pthread_t       t1, t2;
pthread_mutex_t A, B;

void *thread1 (void *args) {
  pthread_mutex_lock (&A);    printf ("t1: locked A\n");
  sched_yield(); // Scheduler
  pthread_mutex_lock (&B);    printf ("t1: locked B\n");
  printf ("thread1: critical!\n"); sleep (1);
  pthread_mutex_unlock (&A);  printf ("t1: unlocked A\n");
  pthread_mutex_unlock (&B);  printf ("t1: unlocked B\n");
}

void *thread2 (void *args) {
  pthread_mutex_lock (&B);    printf ("t2: locked B\n");
  sched_yield(); // Scheduler
  pthread_mutex_lock (&A);    printf ("t2: locked A\n");
  printf ("thread2: critical!\n"); sleep (1);
  pthread_mutex_unlock (&A);  printf ("t2: unlocked A\n");
  pthread_mutex_unlock (&B);  printf ("t2: unlocked B\n");
}

// Kommentarzeichen entfernen, um Cheating zu aktivieren
// #define CHEATING

int main () {
  pthread_mutex_init(&A, NULL);
  pthread_mutex_init(&B, NULL);

  pthread_create (&t1, NULL, thread1, NULL);  // Threads erzeugen
  pthread_create (&t2, NULL, thread2, NULL);

  #ifdef CHEATING
    // Cheating
    sleep (2);
    printf ("main:   Nach 2 Sekunden: Cheat (unlocking A)...\n");
    pthread_mutex_unlock (&A);    // illegal!
  #endif

  pthread_join (t1, NULL);  // Threads einsammeln
  pthread_join (t2, NULL);

  printf ("Fertig\n");
}

